<template>
  <GList
    :rowComponent="rowComponent"
    :columns="columns"
    :loading="loading"
    :loadingMore="loadingMore"
    :resultList="resultList"
    :nbResults="nbResults"
    :hasMore="hasMore"
    :noResultMessage="noResultMessage"
    @loadMore="loadMore"
    @refresh="$emit('refresh')" />
</template>
  
<script>
  
import GList from "./GList.vue";

export default {
  name: "GStoreList",
  components: {
    GList,
  },
  props: {
    rowComponent: {
      type: [String, Object],
      required: true,
    },
    columns: {
      type: Array,
      required: false,
      default: null,
    },
    storeModule: {
      type: String,
      required: true,
    },
    subList: {
      type: [String, Number],
      required: false,
      default: null,
    },
    noResultMessage: {
      type: String,
      required: false,
      default: "Aucun résultat à afficher",
    },
  },
  computed: {
    loading() {
      if (this.subList) {
        return this.$store.getters[this.storeModule + "/getUpdating"](this.subList);
      } else {
        return this.$store.getters[this.storeModule + "/getUpdating"];
      }
    },
    loadingMore() {
      if (this.subList) {
        return this.$store.getters[this.storeModule + "/getLoadingMore"](this.subList);
      } else {
        return this.$store.getters[this.storeModule + "/getLoadingMore"];
      }
    },
    resultList() {
      if (this.subList) {
        return this.$store.getters[this.storeModule + "/getResultList"](this.subList);
      } else {
        return this.$store.getters[this.storeModule + "/getResultList"];
      }
    },
    hasMore() {
      if (this.subList) {
        return this.$store.getters[this.storeModule + "/hasMore"](this.subList);
      } else {
        return this.$store.getters[this.storeModule + "/hasMore"];
      }
    },
    nbResults() {
      if (this.subList) {
        return this.$store.getters[this.storeModule + "/getNbResultTotal"](this.subList);
      } else {
        return this.$store.getters[this.storeModule + "/getNbResultTotal"]; 
      }
    },
  },
  emits: ["refresh"],
  watch: {
    subList() {
      this.initializeResultList();
    },
  },
  mounted() {
    this.initializeResultList();
  },
  methods: {
    initializeResultList() {
      // Refresh only if result list haven't been initialized yet

      if (this.resultList == null) {
        this.refreshResultList();
      }
    },
    refreshResultList() {
      // Force refresh of result list
      if (this.subList) {
        this.$store.dispatch(this.storeModule + "/update", this.subList);
      } else {
        this.$store.dispatch(this.storeModule + "/update"); 
      }
    },
    loadMore() {
      if (this.subList) {
        this.$store.dispatch(this.storeModule + "/loadMore", this.subList);
      } else {
        this.$store.dispatch(this.storeModule + "/loadMore");
      }
    },
  },
};

</script>
